/* **** BEGIN LICENSE BLOCK *****
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is New Tab JumpStart.

The Initial Developer of the Original Code is Mihailo Lalevic.
Copyright (C) 2008, Mihailo Lalevic. All Rights Reserved.

Contributor(s): 
**** END LICENSE BLOCK **** */

var mlalevic;
if (!mlalevic) {
    mlalevic = {};
}

  
if (!mlalevic.JumpStart) {
  mlalevic.JumpStart = {};
}

if (!mlalevic.JumpStart.Preferences) {
    mlalevic.JumpStart.Preferences = {};
}

if (!mlalevic.JumpStart.Services) {
    mlalevic.JumpStart.Services = {};
}


Components.utils.import("resource://modules/browserServices.js", mlalevic.JumpStart.Services);

(function() {
    var Preferences = mlalevic.JumpStart.Preferences;
    var Services = mlalevic.JumpStart.Services;
    var Config = Services.JumpstartConfiguration.Thumbs;
    
    Preferences.OnLoad = function(){
      var configParams = Services.BrowserServices.calculateMaxThumbs();
      
      var tbLines = document.getElementById("thumbLines");
      var tbLinesControl = document.getElementById("thumbLinesControl");
      var tbColumns = document.getElementById("thumbColumnsControl");
      var tbCount = document.getElementById("thumbCount");
      var tbWidth = document.getElementById("containerWidth");
      var tbHeight = document.getElementById("containerHeight");
      
      tbLinesControl.min = Config.MinLines;
      tbLinesControl.max = configParams.lines;
      tbColumns.min = Config.MinColumns;
      tbColumns.max = configParams.columns;
      let lines = configParams.lines < Config.Lines?configParams.lines:Config.Lines;
      lines = lines > Config.MinLines?lines:Config.MinLines;
      tbLines.value = lines;
      tbLinesControl.value = lines; //seems that without this does not enable spin buttons correctly
      let columns = configParams.columns < Config.Columns?configParams.columns:Config.Columns;
      lines = lines > Config.MinColumns?columns:Config.MinColumns;
      tbColumns.value = columns;
      tbCount.value = lines * columns;
      tbHeight.value = Config.ContainerHeight;
      tbWidth.value = Config.ContainerWidth;
    }
    
    Preferences.OnChange = function(){
      //var tbLines = document.getElementById("thumbLines");
      var tbLinesControl = document.getElementById("thumbLinesControl");
      var tbColumns = document.getElementById("thumbColumnsControl");
      var tbCount = document.getElementById("thumbCount");
      var tbWidth = document.getElementById("containerWidth");
      var tbHeight = document.getElementById("containerHeight");
      var prefNormalWidth = document.getElementById("normalWidth");
      var prefNormalHeight = document.getElementById("normalHeight");
      var prefSmallWidth = document.getElementById("smallWidth");
      var prefSmallHeight = document.getElementById("smallHeight");
      
      tbCount.value = tbLinesControl.value * tbColumns.value;
      
      var height = tbLinesControl.value * (prefNormalHeight.value + 25); //TODO: (ML) put this in browser services
      var width = tbColumns.value * (prefNormalWidth.value + 15); //TODO: (ML) put this in browser services
      tbHeight.value = height;
      tbWidth.value =  width;
      
      //calculate small size
      var columns = tbColumns.value;
      var smallWidth = Math.floor((width - (Config.LargeWidth + 14))/(columns - 1)) - 14; //TODO: (ML) move to browser services
      var smallHeight = Math.floor(smallWidth / 1.44);
      prefSmallWidth.value = smallWidth;
      prefSmallHeight.value = smallHeight;
      
    }
    
    Preferences.OnShowSmallChange = function(){

      var tbLines = document.getElementById("thumbLines");
      var tbLinesControl = document.getElementById("thumbLinesControl");
      var tbColumns = document.getElementById("thumbColumnsControl");
      var tbCount = document.getElementById("thumbCount");
      var tbWidth = document.getElementById("containerWidth");
      var tbHeight = document.getElementById("containerHeight");
      var cbSmall = document.getElementById("thumbShowSmallControl");
      
      var prefNormalWidth = document.getElementById("normalWidth");
      var prefNormalHeight = document.getElementById("normalHeight");
      var prefSmallWidth = document.getElementById("smallWidth");
      var prefSmallHeight = document.getElementById("smallHeight");
      
      if(cbSmall.checked){
        prefNormalHeight.value = Config.DefaultSmallHeight;
        prefNormalWidth.value = Config.DefaultSmallWidth;
      }else{
        prefNormalHeight.value = Config.DefaultHeight;
        prefNormalWidth.value = Config.DefaultWidth;
      }
      
      var configForCalculation = {
        ShowSmallThumbs: cbSmall.checked,
        DefaultSmallWidth: Config.DefaultSmallWidth,
        DefaultWidth: Config.DefaultWidth,
        DefaultSmallHeight: Config.DefaultSmallHeight,
        DefaultHeight: Config.DefaultHeight,
        LargeHeight: Config.LargeHeight,
        NormalHeight: prefNormalHeight.value,
        NormalWidth: prefNormalWidth.value,
        MinColumns: Config.MinColumns,
        MinLines: Config.MinLines
      };
      
      var configParams = Services.BrowserServices.calculateMaxThumbs(configForCalculation);
      
      tbLinesControl.min = Config.MinLines;
      tbLinesControl.max = configParams.lines;
      tbColumns.min = Config.MinColumns;
      tbColumns.max = configParams.columns;
      let lines = configParams.lines < Config.Lines?configParams.lines:Config.Lines;
      lines = lines > Config.MinLines?lines:Config.MinLines;
      tbLines.value = lines;
      tbLinesControl.value = lines; //seems that without this does not enable spin buttons correctly
      let columns = configParams.columns < Config.Columns?configParams.columns:Config.Columns;
      lines = lines > Config.MinColumns?columns:Config.MinColumns;
      tbColumns.value = columns;
      tbCount.value = lines * columns;
      
      var height = tbLines.value * (prefNormalHeight.value + 25); //TODO: (ML) put this in browser services
      var width = tbColumns.value * (prefNormalWidth.value + 15); //TODO: (ML) put this in browser services
      
      tbHeight.value = height;
      tbWidth.value = width;
      
      //calculate small size
      var smallWidth = Math.floor((width - (Config.LargeWidth + 14))/(columns - 1)) - 14; //TODO: (ML) move to browser services
      var smallHeight = Math.floor(smallWidth / 1.44);
      prefSmallWidth.value = smallWidth;
      prefSmallHeight.value = smallHeight;
    }
})();